
package edu.uwec.cs.wickmr.life.command;

import java.util.List;
/*
 * 
 * This class represents the Alive state in the game of life.
 */
public class DeadState extends CellState {
	protected static DeadState instance = null;
	
	private DeadState(){
	}
	
	public static DeadState create(){
		if ( instance == null ){
			instance = new DeadState();
		}
		return instance;
	}
	//	Defines the behavior of a dead state coming to life.
	public CellState live(){
		return AliveState.create();
	}
	//	Defines the bahavior of a dead state response to the isAlive question.
	public boolean isAlive(){
		return false;
	}
	//	Defines the toggle behavior for a dead state.
	public CellState toggle(){
		return live();
	}
	
	public void addToLiveNeighbors(List liveNeighbors){
		// Don't add yourself as you are dead.
	}
}
