
package edu.uwec.cs.wickmr.life.visitor;

import java.util.List;
/*
 * 
 * Represents the abstract super class of all concrete states.
 */
public abstract class CellState {
	// Defines the default live behavior of all states.	
	public CellState live(){
		return this;
	}
	
	// Defines the default die behavior of all states.
	public CellState die(){
		return this;
	}
	// Defines the toggle behavior of the state.
	public abstract CellState toggle();
	
	// Defines the isAlive behavior of the state.
	public abstract boolean isAlive();
	
	// Adds this instance to the list of the instance is alive.
	public abstract void addToLiveNeighbors(List liveNeighbors);
	
	public abstract void accept(LifeVisitor visitor, Cell cell, GameOfLife game, List cmds);
}
